#the pre.devs create a device to use when called with filename and path arguments
#the devs$create must accept width and height arguments

a4<-list(width=297/25.4,height=210/25.4);

bitmap.pre.dev<-function(file.name='plot',dir.path='./',res=300, h=a4$height, w=a4$width, ...){
	list( 
		create=function(height=h,width=w,extra=""){ 
			name<-paste(dir.path,file.name,extra,'.png',sep='');
			bitmap(file=name,width=width,height=height,res=res,type="png16m",pointsize=9) 
		},
		close=dev.off
	);
}

psbitmap.pre.dev<-function(file.name='plot',dir.path='./',res=300, h=a4$height, w=a4$width, ...){
	list( 
		create=function(height=h,width=w,extra=""){ 
			name<-paste(dir.path,file.name,extra,'.ps',sep='');
			bitmap(file=name,width=width,height=height,res=res,type="psrgb",pointsize=9) 
		},
		close=dev.off
	);
}

postscript.pre.dev<-function(file.name='plot',dir.path='./', h=a4$height, w=a4$width, ...){
	list( 
		create=function(height=h,width=w,extra=""){ 
			name<-paste(dir.path,file.name,extra,'.ps',sep='');
			postscript(file=name,width=width,height=height,title=file.name,horizontal=F,paper="special")
		},
		close=dev.off
	);
}

pdf.pre.dev<-function(file.name='plot',dir.path='./', h=a4$height, w=a4$width, ...){
	list( 
		create=function(height=h,width=w,extra=""){ 
			name<-paste(dir.path,file.name,extra,'.pdf',sep='');
			pdf(file=name,width=width,height=height,title=file.name)
		},
		close=dev.off
	);
}

x11.pre.dev<-function(file.name="",dir.path="disregarded", h=a4$height, w=a4$width, closeOnClose=F, ...){
	list( create=function(height=h,width=w,extra="disregarded"){x11(width=width,height=height)}, close=function(){if(closeOnClose) dev.off()})
}

quartz.pre.dev<-function(file.name="",dir.path="disregarded", h=a4$height, w=a4$width, closeOnClose=F, ...){
	list( create=function(extra="disregarded",...){quartz(...)}, close=function(){if(closeOnClose) dev.off()})
}

no.pre.dev<-function(...){ #does nothing
	list( create=function(...){}, close=function(){})
}

default.pre.dev<-x11.pre.dev;
